import _default15 from 'ramda/src/assocPath';
import _default14 from 'ramda/src/prop';
import _default13 from 'ramda/src/always';
import _default12 from 'ramda/src/ifElse';
import _default11 from 'ramda/src/filter';
import _default10 from 'ramda/src/map';
import _default9 from 'ramda/src/isNil';
import _default8 from 'ramda/src/reject';
import _default7 from 'ramda/src/pathOr';
import _default6 from 'ramda/src/compose';
import _default5 from 'ramda/src/call';
import _default4 from 'ramda/src/converge';
import _default3 from 'ramda/src/identity';
import _default2 from 'ramda/src/find';
import _default from 'ramda/src/is';

import { coerceToFn } from '../util';

var makeQuery = function makeQuery(query) {
    if (_default(Array, query)) {
        var buildQuery = _default2(_default(Function), query) || _default3;
        var raw = _default2(_default(String), query) || '';
        return buildQuery(raw);
    } else if (_default(String, query)) {
        return query;
    }
    return null;
};

export var getQueries = _default4(_default5, [_default6(coerceToFn, _default7({}, ['options', 'queries'])), _default3]);

export var makeQueries = _default6(_default8(_default9), _default10(makeQuery), getQueries);

export var getRawQueries = _default6(_default11(_default(String)), _default10(_default12(_default(Array), _default2(_default(String)), _default13(null))), _default14('queries'));

/**
 * Copies the string values from the Duck's queries into `consts.queries`.
 *
 * @func
 * @sig {k: v} -> {k: v}
 * @param {Object} duck A duck which (may) contain queries (inside of its 'options')
 * @returns {Object} A clone of the duck, but now with `consts.queries`.
 */
export var copyRawQueriesToConsts = _default4(_default15(['consts', 'queries']), [getRawQueries, _default3]);